# -*- coding:japanese-shift-jis-dos; tab-width:4; -*-
#
# jargon-gra.pl
# $Id: jargon-gra.pl 2.0 2004/08/24 22:03:22 satomii Exp $
#
# Copyright (C) 2000-2004 Satomi I.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
# Public License for more details.
#

use strict;
use Getopt::Long;
use XML::LibXML::Common;
use JargonXml;

my $bmpdir = '';
my $outfile = '';
my $fh;

if (!GetOptions('bmpdir=s' => \$bmpdir,
				'outfile=s' => \$outfile)
		|| !@ARGV
		|| 0 < $#ARGV) {
	die "Usage: $0 [-bmpdir=DIR] [-outfile=FILE] JARGON-XML-FILE\n";
}

if ($outfile) {
	open(OUT, ">$outfile")
		|| die "Unable to create output file: $outfile ($!)\n";
	$fh = *OUT;
} else {
	$fh = *STDOUT;
}

$bmpdir =~ s/([^:\\\/])$/$1\//;

my $xml = new JargonXml;
my $doc = $xml->parse_file($ARGV[0]);
my @files;

foreach my $node ($doc->findnodes('//mediaobject/imageobject/imagedata')) {
	$_ = $node->findvalue('@fileref');
	if ($_) {
		$_ = decodeFromUTF8('euc-jp', $_);
		s/^graphics\///;
		push(@files, $_);
	} else {
		warn "Missing fileref: " . $node->toString() . "\n";
	}
}

@files = sort(@files);
foreach my $file (@files) {
	$_ = $file;
	s/\./_/g;
	print $fh "$_\t$bmpdir$file.bmp\n";
}

close($fh) if (*STDOUT != $fh);
exit(0);
